package graph;

import java.awt.*;
import java.applet.*;
import java.net.URL;
import java.util.*;

/*
**************************************************************************
**
**    Class  FileDialogPopup
**
**************************************************************************
** Copyright (c) 1998
**      The Regents of the University of California.  All rights reserved.
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions
** are met:
** 1. Redistributions of source code must retain the above copyright
**    notice, this list of conditions and the following disclaimer.
** 2. Redistributions in binary form must reproduce the above copyright
**    notice, this list of conditions and the following disclaimer in the
**    documentation and/or other materials provided with the distribution.
** 3. All advertising materials mentioning features or use of this software
**    must display the following acknowledgement:
**      This product includes software developed by the University of
**      California, Berkeley and its contributors.
** 4. Neither the name of the University nor the names of its contributors
**    may be used to endorse or promote products derived from this software
**    without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
** ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
** IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
** ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
** FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
** DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
** OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
** HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
** LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
** OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
** SUCH DAMAGE.
**
** Written by Mark Stemm (stemm@cs.berkeley.edu)
**************************************************************************
**
**    This class creates a file Dialog popup window. It is used by the
**    PrintGraph object to select an output file for postscript
**    output.
**
*************************************************************************/

/**
 * This class creates a file Dialog popup window. It is used by the
 * PrintGraph object to select an output file for postscript
 * output. 
 * @version  $Revision: 1.2 $, $Date: 1998/04/13 22:20:43 $.
 * @author   Mark Stemm (stemm@cs.berkeley.edu)
 */ 

public class FileDialogPopup extends Frame {
  /*
***********************
** Public Variables      
**********************/

  /**
   * The underlying fileDialog widget
   */
  public FileDialog fileDialog;

  /*
*********************
** Constructors
********************/

  /**
   * Create the underlying fileDialog and show it. The arguments are
   * the same as for the FileDialog constructor.
   */
      
  public FileDialogPopup(String label, int option)
  {
    fileDialog = new FileDialog(this, label, option);
    fileDialog.pack();
    fileDialog.show();
  }
/*
*********************
** Public Methods
********************/
  
  /**
   * Get the currently selected file from the fileDialog and return it as a String.
   */
  public String getFile()
  {
    return(fileDialog.getFile());
  }
}
