/*
 * Copyright (c) 1996-1998 Regents of the University of California.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the SPAND Research
 *      Group at the University of California Berkeley.
 * 4. Neither the name of the University nor of the Research Group may be
 *    used to endorse or promote products derived from this software without
 *    specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */
/* $Header: /home/stemm/cvs/Socket++/RelMulti.h,v 1.4 1998/06/08 15:14:55 ss Exp $ */
#if 0

#ifndef SS_SOCKET_REL_MULTI
#define SS_SOCKET_REL_MULTI

#include "Socket.h"
#include "dbgprintlib.h"

#define SOCK_DEFAULT_TTL                        4

class RelMultiSocket : public UdpSocket {
#ifndef MULTICAST
public:
    RelMultiSocket() {state_ = SOCK_STATE_CLOSED;}
    RelMultiSocket(int isCtrl) {state_ = SOCK_STATE_CLOSED;}
    Sock_Status Connect(char *address, Port port) {return(SOCK_FAILURE);}
    /* should have a MTU size! */
    inline void SetMTU(int value) {}
    inline void SetTTL(int value) {}
    inline int GetTTL() {return SOCK_FAILURE;}
#else
public:
    RelMultiSocket();
    RelMultiSocket(int isCtrl);
    Sock_Status Connect(char *address, Port port);
    /* should have a MTU size! */
    inline void SetMTU(int value) {mtu_ = value;};
    inline void SetTTL(int value) {
	ttl_ = (char) value;
	if (setsockopt(sfd_,IPPROTO_IP,IP_MULTICAST_TTL,(char *)&ttl_, 
		       sizeof(ttl_))<0)
	    debug_perror(10, "Sock_Connect: ip_multicast_ttl");
    }
    inline int GetTTL() {return ttl_;}
protected:
    Sock_Status InitSocket();
    u_int mtu_;
    u_char ttl_;
#endif /* MULTICAST */
};

#endif /* SS_SOCKET_REL_MULTI */

#endif /* 0 */
