/*
 * Copyright (c) 1996-1998 Regents of the University of California.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the SPAND Research
 *      Group at the University of California Berkeley.
 * 4. Neither the name of the University nor of the Research Group may be
 *    used to endorse or promote products derived from this software without
 *    specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */
/* $Header: /home/stemm/cvs/dbgprint/dbgprintlib.h,v 1.5 1998/06/10 23:20:14 stemm Exp $ */
#ifndef DBGPRINTLIB
#define DBGPRINTLIB
/** @name dbgprint library
This library is used for printing of debug messages. Every debug message has a debugging level associated with it. The message is actually printed if the level of the debug message is smaller than the current debug level. Increasing the debug level results in more messages being printed.
 * @author SPAND Group, UC Berkeley.
 * @version $Revision: 1.5 $.
 */
    
//@{
#if defined(__cplusplus)
extern "C" {
    /** Set a new debugging level for debug_printf output */
    int SetDebugLevel(int level);
    /** Set the file for debug output */
    int SetDebugFile(char *filename);
    /** Flush pending data to the debug file */
    int FlushDebugFile();
    /** Print the printf if the current debug level is high enough. */
    int debug_printf(int level, const char *format, ...);
    /** Print the perror if the current debug level is high enough */
    int debug_perror(int level, const char *format, ...);
    /** Set a new debugging level for debug_perror messages */
    int SetDperrorLevel(int level);
}
#else
extern int SetDebugLevel(int level);
extern int SetDebugFile(char *filename);
extern int FlushDebugFile();
extern int debug_printf(int level, const char *format, ...);
extern int debug_perror(int level, const char *format, ...);
extern int SetDperrorLevel(int level);
#endif
//@}
#endif
